//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern double Period1         =  10;
extern double Period2         =  4;
extern int    Price           = PRICE_CLOSE;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;


double di[];
double dihu[];
double dihd[];
double dihbu[];
double dihbd[]; 
double trend[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,dihu);     SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dihd);     SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,dihbu);    SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,dihbd);    SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,di);
   SetIndexBuffer(5,trend);
   
      indicatorFileName = WindowExpertName();
      calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
      returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
      timeFrame         = stringToTimeFrame(TimeFrame);
   
      IndicatorShortName(timeFrameToString(timeFrame)+" Blau ergodic divergence candles ("+DoubleToStr(Period1,1)+","+DoubleToStr(Period2,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { dihu[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(int i=limit; i>=0; i--)
      {
         double priceDiff = iMA(NULL,0,1,0,MODE_SMA,Price,i)-iMA(NULL,0,1,0,MODE_SMA,Price,i+1);
            di[i] = 100.0*iEma(iEma( priceDiff ,Period1,i,0),Period2,i,1);

            //
            //
            //
            //
            //
            
            dihu[i]    = EMPTY_VALUE;
            dihd[i]    = EMPTY_VALUE;
            dihbu[i]   = EMPTY_VALUE;
            dihbd[i]   = EMPTY_VALUE;             
            trend[i] = trend[i+1];
               if (di[i] > 0)  trend[i] =  1;
               if (di[i] < 0)  trend[i] = -1;
               if (trend[i] == 1)
               {  
                  dihu[i]  = High[i]; 
                  dihd[i]  = Low[i];
                  dihbu[i] = MathMax(Open[i],Close[i]);
                  dihbd[i] = MathMin(Open[i],Close[i]); 
               }
               if (trend[i] ==-1)
               {  
                  dihu[i]  = Low[i];
                  dihd[i]  = High[i];
                  dihbu[i] = MathMin(Open[i],Close[i]);
                  dihbd[i] = MathMax(Open[i],Close[i]); 
               }
               
      }
      manageAlerts();
      return(0);
   }

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,5,y);
         dihu[i]  = EMPTY_VALUE;
         dihd[i]  = EMPTY_VALUE;
         dihbu[i] = EMPTY_VALUE;
         dihbd[i] = EMPTY_VALUE;     
         
         if (trend[i] == 1)
         {  
            dihu[i]  = High[i]; 
            dihd[i]  = Low[i];
            dihbu[i] = MathMax(Open[i],Close[i]);
            dihbd[i] = MathMin(Open[i],Close[i]); 
         }
         if (trend[i] ==-1)
         {  
            dihu[i]  = Low[i];
            dihd[i]  = High[i];
            dihbu[i] = MathMin(Open[i],Close[i]);
            dihbd[i] = MathMax(Open[i],Close[i]); 
         }
   }
   return(0);
         
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][5];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
       
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar," crossing zero line up");
         if (trend[whichBar] ==-1) doAlert(whichBar," crossing zero line down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Blau di candles ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Blau di candles "),message);
          if (alertsNotify)  SendNotification(message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(StrToInteger(tfs));
}
string timeFrameToString(int tf){
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
return(s);
}